#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>

typedef unsigned long prime;


prime ferm(prime a, prime m, prime p) { // a - zaklad, m - exponent, p - modulo

  prime s, t, i, j;

  s = 1;
  j = 0;
  while (j < m) {

    t = a%p;
    i = 1;
    while ((i + j) <= m) {
      i *= 2;
      if ((i + j) <= m) t = (t*t)%p;
    }
    s = (s*t)%p;
    j = i/2 + j;

  }

  return s;
}


int rmtest(prime p) {
  int test;
  prime a, j, z, m, b;

  m = p-1;
  b = 0;
  while (m%2 == 0) {
    m /= 2;
    b ++;
  }

  randomize();
  if (p < 10000) a = random(p-100)+100;
  else a = random(10000-100)+100;

  j = 0;
  z = ferm(a, m, p);

  if ((z == 1)||(z == p - 1)) test = 1;
  else {
      j ++;

      while ((j < b)&&(z != p-1)) {
	z = (z*z)%p;
	if (z == 1) {
	  test = 0;
	  break;
	}
	j ++;
      }

      if (z == p-1) test = 1;
      if ((j == b)&&(z != p-1)) test = 0;
    }

  return(test);
}


void main(void) {
// tohle taky funguje
/*
  FILE *f;
  char *soubor = "prime1.txt";
  f = fopen(soubor, "w");
  if (f == NULL) exit(1);

  prime p;
  char male[20] = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71};
  int test, i;

  randomize();

  for (p = 1000; p < 50000; p ++) {
    test = 1;

    for (i = 0; i < 20; i ++) {
      if (p%male[i] == 0) {
	test = 0;
      }
    }

    if (test == 1) {
      for (i = 0; i < 6; i ++) {
	test = rmtest(p);
	if (test == 0) break;
      }
      if (test == 1) {
	printf("%ld\n", p);
	fprintf(f,"%ld\n", p);
      }
    }
  }

  fclose(f);
*/
  if (rmtest(510509)) printf("je\n");
}